import SideNav from '../../components/layout/page';
import { SidebarNav } from "../../app/dashboard/components/sidebar-nav";
import Logout from "../../components/logout";
export var metadata = {
    title: "Forms",
    description: "Advanced form example using react-hook-form and Zod.",
};
var sidebarNavItems = [
    {
        title: "Roles",
        href: "/dashboard/role",
    },
    {
        title: "Tenant",
        href: "/dashboard/tenant",
    },
    {
        title: "User",
        href: "/dashboard/user",
    },
    {
        title: "Dashboard",
        href: "/dashboard",
    },
];
export default function SettingsLayout(_a) {
    var children = _a.children;
    return (<>

            <div className="h-screen w-full pl-[56px]">
                <SideNav />
                <header className="sticky top-0 z-10 flex h-[57px] justify-between items-center gap-1 border-b bg-background px-4">
                    <h1 className="text-xl font-semibold">Playground</h1>

                   <Logout />
                </header>
                <div className="flex flex-col sm:flex-row">
                    <div className="w-full sm:border-b md:border-r md:w-1/6 md:h-screen fixed overflow-auto ">
                        {/* First section */}
                        <SidebarNav items={sidebarNavItems}/>
                    </div>
                    <div className="w-full mt-12 md:mt-0 md:ml-[16.666667%] px-6 pt-2 h-screen overflow-auto">
                        {/* Second section */}
                        {children}
                    </div>
                </div>
            </div>
        </>);
}
