var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { useState, useEffect } from 'react';
import { zodResolver } from "@hookform/resolvers/zod";
import { useForm } from "react-hook-form";
import { z } from "zod";
import { Separator } from "../../../../components/ui/separator";
import { Checkbox } from "../../../../components/ui/checkbox";
import { Form } from "../../../../components/ui/form";
import { FormProvider, FuzSelect, FuzMultiButton, FuzTextField, } from "../../../../components/hook-form";
import { toast } from "../../../../components/ui/use-toast";
import { roleSchema } from '../data/schema';
// Define schema using Zod based on the ven
// Define schema using Zod based on the vendors table structure
export default function VendorForm(_a) {
    var defaultValue = _a.defaultValue, isEdit = _a.isEdit, setShowSideNav = _a.setShowSideNav, onRefresh = _a.onRefresh, supabase = _a.supabase;
    var _b = useState(false), loader = _b[0], setLoader = _b[1];
    var _c = useState(["SA", "A", "S"]), setRole_idData = _c[1];
    var _d = useState({}), permission = _d[0], setPermission = _d[1];
    var _e = useState([]), rolesList = _e[0], setRolesList = _e[1];
    var defaultValues = {
        id: (defaultValue === null || defaultValue === void 0 ? void 0 : defaultValue.id) || "",
        name: (defaultValue === null || defaultValue === void 0 ? void 0 : defaultValue.name) || "",
        type: (defaultValue === null || defaultValue === void 0 ? void 0 : defaultValue.type) || "",
        description: (defaultValue === null || defaultValue === void 0 ? void 0 : defaultValue.description) || "",
        access_level: (defaultValue === null || defaultValue === void 0 ? void 0 : defaultValue.access_level) || {},
        status: (defaultValue === null || defaultValue === void 0 ? void 0 : defaultValue.status) || "",
        is_default: (defaultValue === null || defaultValue === void 0 ? void 0 : defaultValue.is_default) || false,
        created_by: (defaultValue === null || defaultValue === void 0 ? void 0 : defaultValue.created_by) || "00000000-0000-0000-0000-000000000000",
        modified_by: (defaultValue === null || defaultValue === void 0 ? void 0 : defaultValue.modified_by) || "00000000-0000-0000-0000-000000000000",
        tenant_id: (defaultValue === null || defaultValue === void 0 ? void 0 : defaultValue.tenant_id) || '00000000-0000-0000-0000-000000000000',
        created_at: (defaultValue === null || defaultValue === void 0 ? void 0 : defaultValue.created_at) || new Date(),
        updated_at: (defaultValue === null || defaultValue === void 0 ? void 0 : defaultValue.updated_at) || new Date(),
        permissionType: undefined
    };
    var editSchema = z.object({
        name: z.string().min(1, 'Name is required'),
        permissionType: z.object({}),
        access_level: z.record(z.string()),
    });
    // Schema for other cases (when not editing)
    var defaultSchema = z.object({
        name: z.string().min(1, 'Name is required'),
        access_level: z.record(z.string()),
    });
    // Define which schema to use based on the value of isEdit
    var schema = isEdit === true ? defaultSchema : editSchema;
    var form = useForm({
        resolver: zodResolver(schema),
        defaultValues: defaultValues,
    });
    var setValue = form.setValue, watch = form.watch, getValues = form.getValues;
    var values = getValues();
    var watchValues = watch();
    console.log("values", values.permissionType);
    useEffect(function () {
        console.log('permissionType', values.permissionType, watchValues === null || watchValues === void 0 ? void 0 : watchValues.permissionType);
        if (values === null || values === void 0 ? void 0 : values.permissionType) {
            var tempAcc = watchValues === null || watchValues === void 0 ? void 0 : watchValues.permissionType;
            setPermission(tempAcc);
        }
    }, [watchValues.permissionType]);
    useEffect(function () {
        var access_level = watchValues.permissionType;
        console.log("mytype", watchValues.permissionType);
        console.log("mytype", rolesList);
        if (access_level && rolesList.length > 0) {
            var filteredRoles = rolesList.filter(function (role) {
                if (typeof role === 'object' && role !== null && 'access_level' in role) {
                    return role.access_level === access_level;
                }
                return false;
            });
            console.log("mytype", filteredRoles);
            if (filteredRoles.length > 0) {
                setValue('type', filteredRoles[0].type || '');
            }
            else {
                setValue('type', ''); // Set default value if no matching roles found
            }
        }
        else {
            setValue('type', ''); // Set default value if rolesList is empty or permissionType is falsy
        }
    }, [watchValues.permissionType, rolesList]);
    useEffect(function () {
        setValue('access_level', permission);
    }, [permission]);
    console.log("permission", permission);
    useEffect(function () {
        function fetchDataFromTable(tableName, setStateCallback) {
            return __awaiter(this, void 0, void 0, function () {
                var _a, data, error, err_1;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _b.trys.push([0, 2, , 3]);
                            return [4 /*yield*/, supabase.from('tenant').select('*')];
                        case 1:
                            _a = _b.sent(), data = _a.data, error = _a.error;
                            if (error) {
                                console.error("Error fetching data from ".concat(tableName, ":"), error.message);
                            }
                            else {
                                setStateCallback(data || []);
                            }
                            return [3 /*break*/, 3];
                        case 2:
                            err_1 = _b.sent();
                            console.error("Error fetching data from ".concat(tableName, ":"), err_1);
                            return [3 /*break*/, 3];
                        case 3: return [2 /*return*/];
                    }
                });
            });
        }
        fetchDataFromTable('roles', setRole_idData);
    }, []);
    useEffect(function () {
        function getRoles() {
            return __awaiter(this, void 0, void 0, function () {
                var _a, data, error;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0: return [4 /*yield*/, supabase.auth.rolesList()];
                        case 1:
                            _a = _b.sent(), data = _a.data, error = _a.error;
                            if (error) {
                                console.error("Error fetching tenants:", error.message);
                                setRolesList([]);
                            }
                            else {
                                console.log('rolesList', z.array(roleSchema).parse(data.role.roles));
                                setRolesList(z.array(roleSchema).parse(data.role.roles));
                            }
                            return [2 /*return*/];
                    }
                });
            });
        }
        getRoles();
    }, []);
    console.log('rolesList', rolesList);
    useEffect(function () {
        var _a, _b;
        if (isEdit) {
            var tempPer = defaultValue === null || defaultValue === void 0 ? void 0 : defaultValue.access_level;
            setPermission(tempPer);
        }
        else {
            console.log("test", (_a = rolesList[0]) === null || _a === void 0 ? void 0 : _a.access_level);
            var tempAcc = rolesList && ((_b = rolesList[0]) === null || _b === void 0 ? void 0 : _b.access_level);
            console.log("tempAcc", tempAcc);
            // setPermission(tempAcc)
        }
    }, [defaultValue, rolesList]);
    function onSubmit(data) {
        return __awaiter(this, void 0, void 0, function () {
            var obj, error_1, obj, error, err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 5, , 6]);
                        if (!isEdit) return [3 /*break*/, 2];
                        setLoader(true);
                        console.log("datas", values);
                        obj = __assign(__assign({}, data), { type: values.type, id: values.id, description: values.description });
                        return [4 /*yield*/, supabase.auth.updateRole(obj)];
                    case 1:
                        error_1 = (_a.sent()).error;
                        if (error_1) {
                            setTimeout(function () {
                                toast({
                                    title: "Error",
                                    variant: "destructive",
                                    description: (<pre className="mt-2 w-[340px] rounded-md bg-slate-950 p-4">
                  <code className="text-white"> <div>
                  {JSON.stringify(error_1, null, 2)}
                  </div></code>
                </pre>),
                                });
                                setLoader(false);
                            }, 2000);
                        }
                        else {
                            setTimeout(function () {
                                setLoader(false);
                                form.reset();
                                toast({
                                    title: "You submitted the following values:",
                                    description: (<pre className="mt-2 w-[340px] rounded-md bg-slate-950 p-4">
                  <code className="text-white">Successfully Updated</code>
                </pre>),
                                });
                            }, 2000);
                            onRefresh();
                            setShowSideNav(false);
                        }
                        return [3 /*break*/, 4];
                    case 2:
                        setLoader(true);
                        console.log("datas", values);
                        obj = __assign(__assign({}, data), { type: values.type, description: values.description, is_default: true });
                        return [4 /*yield*/, supabase.auth.createRole(obj)];
                    case 3:
                        error = (_a.sent()).error;
                        if (error) {
                            setTimeout(function () {
                                toast({
                                    title: "Error",
                                    variant: "destructive",
                                    description: (<pre className="mt-2 w-[340px] rounded-md bg-slate-950 p-4">
                  <code className="text-white">Unable to create role</code>
                </pre>),
                                });
                                setLoader(false);
                            }, 2000);
                        }
                        else {
                            setTimeout(function () {
                                setLoader(false);
                                form.reset();
                                toast({
                                    title: "You submitted the following values:",
                                    description: (<pre className="mt-2 w-[340px] rounded-md bg-slate-950 p-4">
                  <code className="text-white">Successfully Created</code>
                </pre>),
                                });
                            }, 2000);
                            onRefresh();
                            setShowSideNav(false);
                        }
                        _a.label = 4;
                    case 4: return [3 /*break*/, 6];
                    case 5:
                        err_2 = _a.sent();
                        console.error('Error fetching customers:', err_2);
                        return [3 /*break*/, 6];
                    case 6: return [2 /*return*/];
                }
            });
        });
    }
    // console.log("dataata",form.getValues())
    return (<div style={{ height: '80vh', overflowY: 'auto' }} className='px-2'> {/* Set height and overflow */}
      <Form {...form}>
        <FormProvider onSubmit={form.handleSubmit(onSubmit)} className="space-y-8">
          <div style={{ fontWeight: '700', fontSize: "20px" }}>
            {/* <h1>ROLE</h1> */}
          </div>
          <div style={{ display: 'grid', gap: '20px' }}>
            <FuzTextField label="Name" name="name" required type="character varying" placeholder="Enter Role name" form={form}/>
            <FuzTextField label="Description" name="description" type="character varying" placeholder="Enter Description" form={form}/>

            {/* <FuzSelect
          label="Type"
          placeholder="type"
          required
          name="type"
          options={role_idData}
          form={form}
        // displayLabel="plan_name"
        // returnLabel="id"
        /> */}
            {/* <FuzSelect
          label="Status"
          placeholder="Select Status"
          required
          name="status"
          options={status_idData}
          form={form}
        // displayLabel="plan_name"
        // returnLabel="id"
        /> */}
          </div>
          <Separator />

          {isEdit === false ? (<FuzSelect label="Role Type" placeholder="Select Role" required name="permissionType" options={rolesList} form={form} 
        //displayLabel={Object.keys(watchValues.permissionType || {}).length === 0 ? "" : "name"}
        displayLabel="name" returnLabel="access_level"/>) : null}
          <div>
          {permission && Object.entries(permission).map(function (_a, index) {
            var key = _a[0], value = _a[1];
            return (<>
  {console.log("index", index, "Key:", key, "Value:", typeof value)}
    {index === 0 && (<div className="grid grid-cols-6 items-center"> {/* Total 6 columns: 1 for the first column, 5 for the second */}
        {/* First column */}
        <div className="col-span-1"/>
        {/* Second column */}
        <div className="col-span-5">
          <div className="grid grid-cols-5 gap-4">
            {["Read", "Write", "Delete", "Import", "Export"].map(function (char, index) { return (<div key={index} className='px-3 py-2'>
                <div className="px-3 py-3 flex items-center gap-x-2 capitalize">
                  {char}
                </div>
              </div>); })}
          </div>
        </div>
      </div>)}

    <div className="grid grid-cols-6 items-center" key={key}>
      {/* First column */}
      <div className="col-span-1">
        <div className="grid grid-cols-1 gap-1">
          <div className="text-md cursor-pointer capitalize">
            {key}
          </div>
        </div>
      </div>
      {/* Second column */}
      <div className="col-span-5">
        <div className="grid grid-cols-5 gap-4">
          {__spreadArray([], value, true).map(function (char, index) { return (<div key={index} className='px-3 py-2'>
              {/* Checkbox for each character (1 or 0) */}
              <div className="px-5 py-3 flex items-center gap-x-2">
                <Checkbox id={"".concat(key, "-").concat(index)} name={"".concat(key, "-").concat(index)} checked={char === "1"} onCheckedChange={function (checked) {
                        var _a;
                        console.log('inside', checked);
                        // Get the updated value for the checkbox
                        var updatedValue = checked ? "1" : "0";
                        // Update permissions state based on checkbox change
                        var newValue = value.substring(0, index) + updatedValue + value.substring(index + 1);
                        console.log('click', newValue);
                        var newPermissions = __assign(__assign({}, permission), (_a = {}, _a[key] = newValue, _a));
                        console.log('inside', checked);
                        setPermission(newPermissions);
                    }}/>
              </div>
            </div>); })}
        </div>
      </div>
    </div>
  </>);
        })}

          </div>
          <Separator />
          <FuzMultiButton submitVariant="default" clearVariant="outline" submitlabel="Submit" clearlabel={isEdit === false ? "Clear" : undefined} submitType="submit" 
    // submitAction={handleSubmit}
    clearAction={function () {
            console.log("form", form);
            form.reset(__assign(__assign({}, defaultValues), { name: '', description: '', permissionType: values.permissionType }));
        }} loader={loader}/>
        </FormProvider>
      </Form>
    </div>);
}
