var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import * as React from "react";
import { Sheet, SheetContent, SheetHeader, SheetTitle, SheetDescription } from "../../../../components/ui/sheet";
import { z } from "zod";
import { roleSchema } from "../data/schema";
import AddEditForm from "./AddEdit";
export default function SideNav(_a) {
    var _this = this;
    var showSideNav = _a.showSideNav, onRefresh = _a.onRefresh, data = _a.data, onClose = _a.onClose, _b = _a.isEdit, isEdit = _b === void 0 ? false : _b, setShowSideNav = _a.setShowSideNav, supabase = _a.supabase;
    var _c = React.useState([]), tenantDetail = _c[0], setTenantDetails = _c[1];
    function getTenants(id) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, data, error;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, supabase.auth.getRoleById({ id: id })];
                    case 1:
                        _a = _b.sent(), data = _a.data, error = _a.error;
                        if (error) {
                            console.error("Error fetching tenant details:", error.message);
                            return [2 /*return*/, []];
                        }
                        // return []
                        return [2 /*return*/, z.array(roleSchema).parse([data.role])];
                }
            });
        });
    }
    // Fetch tenant details when component mounts
    React.useEffect(function () {
        if (showSideNav && (data === null || data === void 0 ? void 0 : data.id)) {
            (function () { return __awaiter(_this, void 0, void 0, function () {
                var details;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, getTenants(data.id)];
                        case 1:
                            details = _a.sent();
                            setTenantDetails(details);
                            return [2 /*return*/];
                    }
                });
            }); })();
        }
    }, [showSideNav, data === null || data === void 0 ? void 0 : data.id]);
    React.useEffect(function () {
        console.log('tenantDetail', tenantDetail);
    }, [tenantDetail]);
    var handleClickOverlay = function () {
        onClose(); // Close the Sheet when clicking on overlay
    };
    return (<Sheet open={showSideNav} onOpenChange={handleClickOverlay}>
      <SheetContent className="w-[800px]" style={{
            maxWidth: '100%'
        }}>
        <SheetHeader className="px-2">
          <SheetTitle>ROLE</SheetTitle>
          <SheetDescription>
            {"".concat(isEdit ? 'Update a role' : 'Create a new role', " ")}
          </SheetDescription>

        </SheetHeader>
        {isEdit && (tenantDetail === null || tenantDetail === void 0 ? void 0 : tenantDetail.length) > 0 ? <AddEditForm onRefresh={onRefresh} setShowSideNav={setShowSideNav} isEdit={isEdit} defaultValue={tenantDetail[0]} supabase={supabase}/> : !isEdit ? <AddEditForm onRefresh={onRefresh} setShowSideNav={setShowSideNav} isEdit={isEdit} defaultValue={undefined} supabase={supabase}/> : "Loading"}
      </SheetContent>
    </Sheet>);
}
