"use client";
import { Checkbox } from "../../../../components/ui/checkbox";
import { statusNew } from "../data/data";
import { DataTableColumnHeader } from "./data-table-column-header";
import { DataTableRowActions } from "./data-table-row-actions";
import SideNav from "./SideNav";
import { useState } from "react";
export var columns = function (_a) {
    var onRefresh = _a.onRefresh, onCallDelete = _a.onCallDelete, supabase = _a.supabase;
    return [
        {
            id: "select",
            header: function (_a) {
                var table = _a.table;
                return (<Checkbox checked={table.getIsAllPageRowsSelected() ?
                        true :
                        (table.getIsSomePageRowsSelected() ? "indeterminate" : false)} onCheckedChange={function (value) { return table.toggleAllPageRowsSelected(!!value); }} aria-label="Select all" className="translate-y-[2px]"/>);
            },
            cell: function (_a) {
                var row = _a.row;
                return (<Checkbox checked={row.getIsSelected()} onCheckedChange={function (value) { return row.toggleSelected(!!value); }} aria-label="Select row" className="translate-y-[2px]"/>);
            },
            enableSorting: false,
            enableHiding: false,
        },
        {
            accessorKey: "name",
            header: function (_a) {
                var column = _a.column;
                return (<DataTableColumnHeader column={column} title="Name"/>);
            },
            cell: function (_a) {
                var row = _a.row;
                return <div className="w-[80px]">{row.getValue("name")}</div>;
            },
            enableSorting: false,
            enableHiding: false,
        },
        {
            accessorKey: "email",
            header: function (_a) {
                var column = _a.column;
                return (<DataTableColumnHeader column={column} title="Email"/>);
            },
            cell: function (_a) {
                var row = _a.row;
                return <div className="w-[80px]">{row.getValue("email")}</div>;
            },
            enableSorting: false,
            enableHiding: false,
        },
        {
            accessorKey: "country_code",
            header: function (_a) {
                var column = _a.column;
                return (<DataTableColumnHeader column={column} title=""/>);
            },
            cell: function (_a) {
                var row = _a.row;
                console.log("Country Code:", row.getValue("country_code"));
                // return <div className="w-[80px]">{row.getValue("country_code")}</div>;
            },
            enableSorting: false,
            enableHiding: false,
        },
        {
            accessorKey: "phone",
            header: function (_a) {
                var column = _a.column;
                return (<DataTableColumnHeader column={column} title="Phone"/>);
            },
            cell: function (_a) {
                var row = _a.row;
                return (<div className="w-[125px]" style={{ width: '' }}>
        {row.getValue("country_code") + "-" + row.getValue("phone")}
      </div>);
            },
            enableSorting: false,
            enableHiding: false,
        },
        // {
        //   accessorKey: "default_user_name",
        //   header: ({ column }) => (
        //     <DataTableColumnHeader column={column} title="Default UserName" />
        //   ),
        //   cell: ({ row }) => {
        //     const label = labels.find((label) => label.value === row.original.default_user_name)
        //     return (
        //       <div className="flex space-x-2">
        //         {label && <Badge variant="outline">{label.label}</Badge>}
        //         <span className="max-w-[500px] truncate font-medium">
        //           {row.getValue("default_user_name")}
        //         </span>
        //       </div>
        //     )
        //   },
        // },
        {
            accessorKey: "status",
            header: function (_a) {
                var column = _a.column;
                return (<DataTableColumnHeader column={column} title="Status"/>);
            },
            cell: function (_a) {
                var row = _a.row;
                var status = statusNew.find(function (status) { return status.value === row.getValue("status"); });
                if (!status) {
                    return null;
                }
                return (<div className="flex w-[100px] items-center">
          {status.icon && (<status.icon className="mr-2 h-4 w-4 text-muted-foreground"/>)}
          <span>{status.label}</span>
        </div>);
            },
            filterFn: function (row, id, value) {
                return value.includes(row.getValue(id));
            },
        },
        // {
        //   accessorKey: "plan_name",
        //   header: ({ column }) => (
        //     <DataTableColumnHeader column={column} title="Plan" />
        //   ),
        //   cell: ({ row }) => {
        //     const priority = planNames.find(
        //       (priority) => priority.value === row.getValue("plan_name")
        //     )
        //     if (!priority) {
        //       return null
        //     }
        //     return (
        //       <div className="flex items-center">
        //         {/* {priority.icon && (
        //           <priority.icon className="mr-2 h-4 w-4 text-muted-foreground" />
        //         )} */}
        //         <span>{priority.label}</span>
        //       </div>
        //     )
        //   },
        //   filterFn: (row, id, value) => {
        //     return value.includes(row.getValue(id))
        //   },
        // },
        {
            id: "actions",
            cell: function (_a) {
                var row = _a.row;
                var _b = useState(false), showSideNav = _b[0], setShowSideNav = _b[1];
                var _c = useState(null), rowData = _c[0], setRowData = _c[1];
                var handleEdit = function (value) {
                    console.log("Edit clicked for:", value === null || value === void 0 ? void 0 : value.id);
                    // Set state to true to show SideNav component
                    setRowData(value);
                    setShowSideNav(true);
                };
                var onClose = function () {
                    setShowSideNav(false);
                };
                var handleDelete = function (value) {
                    console.log("Delete clicked for:", value === null || value === void 0 ? void 0 : value.id);
                    // Set state to true to show SideNav component
                    onCallDelete(value);
                };
                // Conditionally render SideNav based on showSideNav state
                return (<>
          <DataTableRowActions row={row} onEdit={handleEdit} onDelete={handleDelete}/>
          {rowData && <SideNav setShowSideNav={setShowSideNav} onRefresh={onRefresh} isEdit={true} showSideNav={showSideNav} data={rowData} onClose={onClose} supabase={supabase}/>}
        </>);
            },
        },
    ];
};
