"use client";
import { DropdownMenuTrigger } from "@radix-ui/react-dropdown-menu";
import { MixerHorizontalIcon } from "@radix-ui/react-icons";
import { Button } from "../../../../components/ui/button";
import { DropdownMenu, DropdownMenuCheckboxItem, DropdownMenuContent, DropdownMenuLabel, DropdownMenuSeparator, } from "../../../../components/ui/dropdown-menu";
export function DataTableViewOptions(_a) {
    var table = _a.table;
    return (<DropdownMenu>
      <DropdownMenuTrigger asChild>
        <Button variant="outline" size="sm" className="ml-auto hidden h-8 lg:flex">
          <MixerHorizontalIcon className="mr-2 h-4 w-4"/>
          View
        </Button>
      </DropdownMenuTrigger>
      <DropdownMenuContent align="end" className="w-[150px]">
        <DropdownMenuLabel>Toggle columns</DropdownMenuLabel>
        <DropdownMenuSeparator />
        {table
            .getAllColumns()
            .filter(function (column) {
            return typeof column.accessorFn !== "undefined" && column.getCanHide();
        })
            .map(function (column) {
            return (<DropdownMenuCheckboxItem key={column.id} className="capitalize" checked={column.getIsVisible()} onCheckedChange={function (value) { return column.toggleVisibility(!!value); }}>
                {column.id}
              </DropdownMenuCheckboxItem>);
        })}
      </DropdownMenuContent>
    </DropdownMenu>);
}
