var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { useState, useEffect } from 'react';
import { zodResolver } from "@hookform/resolvers/zod";
import { useForm } from "react-hook-form";
import { z } from "zod";
import { Form } from "../../../../components/ui/form";
import { FormProvider, FuzSelect, FuzMultiButton, FuzTextField } from "../../../../components/hook-form";
import { toast } from "../../../../components/ui/use-toast";
// Define schema using Zod based on the ven
// Define schema using Zod based on the vendors table structure
var emailRegex = /^[^\s@]+@[^\s@]+\.[^\s@]+$/;
var schema = z.object({
    name: z.string().min(1, 'Name is required'),
    email: z.string()
        .min(1, { message: 'Email is required' })
        .refine(function (value) { return emailRegex.test(value); }, { message: 'Invalid email format' }),
    password: z.string().min(0, 'Password is required').min(6, 'Password must be at least 6 characters long'),
    role_id: z.string().min(1, 'Role ID is required'),
    phone: z.string().min(1, 'Phone number is required').min(10, 'Invalid phone number'),
    // user_metadata: 
});
var schemaEdit = z.object({
    name: z.string().min(1, 'Name is required'),
    email: z.string()
        .min(1, { message: 'Email is required' })
        .refine(function (value) { return emailRegex.test(value); }, { message: 'Invalid email format' }),
    role_id: z.string().min(1, 'Role ID is required'),
    phone: z.string().min(1, 'Phone number is required').min(10, 'Invalid phone number'),
    // user_metadata: 
});
export default function VendorForm(_a) {
    var defaultValue = _a.defaultValue, isEdit = _a.isEdit, onReferesh = _a.onReferesh, setShowSideNav = _a.setShowSideNav, supabaseAuthAdmin = _a.supabaseAuthAdmin;
    var _b = useState(false), loader = _b[0], setLoader = _b[1];
    var _c = useState([]), role_idData = _c[0], setRole_idData = _c[1];
    var defaultValues = {
        id: (defaultValue === null || defaultValue === void 0 ? void 0 : defaultValue.id) || "",
        email: (defaultValue === null || defaultValue === void 0 ? void 0 : defaultValue.email) || "",
        password: (defaultValue === null || defaultValue === void 0 ? void 0 : defaultValue.password) || "",
        phone: (defaultValue === null || defaultValue === void 0 ? void 0 : defaultValue.phone) || "",
        role_id: (defaultValue === null || defaultValue === void 0 ? void 0 : defaultValue.role_id) || "",
        name: (defaultValue === null || defaultValue === void 0 ? void 0 : defaultValue.user_metadata.name) || "",
    };
    var form = useForm({
        resolver: isEdit ? zodResolver(schemaEdit) : zodResolver(schema),
        defaultValues: defaultValues,
    });
    console.log("defaultValues", defaultValues);
    useEffect(function () {
        function fetchDataFromTable(tableName, setStateCallback) {
            return __awaiter(this, void 0, void 0, function () {
                var _a, data, error, err_1;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _b.trys.push([0, 2, , 3]);
                            return [4 /*yield*/, supabaseAuthAdmin.auth.rolesList()];
                        case 1:
                            _a = _b.sent(), data = _a.data, error = _a.error;
                            if (error) {
                                console.error("Error fetching data from ".concat(tableName, ":"), error.message);
                                setStateCallback([]);
                            }
                            else {
                                setStateCallback(data.role.roles);
                            }
                            return [3 /*break*/, 3];
                        case 2:
                            err_1 = _b.sent();
                            console.error("Error fetching data from ".concat(tableName, ":"), err_1);
                            return [3 /*break*/, 3];
                        case 3: return [2 /*return*/];
                    }
                });
            });
        }
        fetchDataFromTable('roles', setRole_idData);
    }, []);
    function onSubmit(_data) {
        return __awaiter(this, void 0, void 0, function () {
            var values, password, name_1, rest, obj, error, values, name_2, rest, obj, error, err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 5, , 6]);
                        if (!isEdit) return [3 /*break*/, 2];
                        setLoader(true);
                        values = form.getValues();
                        password = values.password, name_1 = values.name, rest = __rest(values, ["password", "name"]);
                        obj = __assign(__assign({}, rest), { user_metadata: {
                                name: values.name
                            } });
                        return [4 /*yield*/, supabaseAuthAdmin.auth.admin.updateUserById(obj.id, obj)];
                    case 1:
                        error = (_a.sent()).error;
                        if (error) {
                            setTimeout(function () {
                                toast({
                                    title: "Error",
                                    variant: "destructive",
                                    description: (<pre className="mt-2 w-[340px] rounded-md bg-slate-950 p-4">
                  <code className="text-white">Something Went Wrong</code>
                </pre>),
                                });
                                setLoader(false);
                            }, 2000);
                        }
                        else {
                            onReferesh();
                            setShowSideNav(false);
                            setTimeout(function () {
                                setLoader(false);
                                form.reset();
                                toast({
                                    title: "You submitted the following values:",
                                    description: (<pre className="mt-2 w-[340px] rounded-md bg-slate-950 p-4">
                  <code className="text-white">Successfully Updated</code>
                </pre>),
                                });
                            }, 2000);
                        }
                        return [3 /*break*/, 4];
                    case 2:
                        setLoader(true);
                        values = form.getValues();
                        name_2 = values.name, rest = __rest(values, ["name"]);
                        obj = __assign(__assign({}, rest), { user_metadata: {
                                name: values.name
                            } });
                        return [4 /*yield*/, supabaseAuthAdmin.auth.admin.createUser(obj)];
                    case 3:
                        error = (_a.sent()).error;
                        if (error) {
                            setTimeout(function () {
                                toast({
                                    title: "Error",
                                    variant: "destructive",
                                    description: (<pre className="mt-2 w-[340px] rounded-md bg-slate-950 p-4">
                  <code className="text-white">Something Went Wrong</code>
                </pre>),
                                });
                                setLoader(false);
                            }, 2000);
                        }
                        else {
                            setTimeout(function () {
                                onReferesh();
                                setLoader(false);
                                setShowSideNav(false);
                                form.reset();
                                toast({
                                    title: "You submitted the following values:",
                                    description: (<pre className="mt-2 w-[340px] rounded-md bg-slate-950 p-4">
                  <code className="text-white">Successfully Created</code>
                </pre>),
                                });
                            }, 2000);
                        }
                        _a.label = 4;
                    case 4: return [3 /*break*/, 6];
                    case 5:
                        err_2 = _a.sent();
                        console.error('Error fetching customers:', err_2);
                        return [3 /*break*/, 6];
                    case 6: return [2 /*return*/];
                }
            });
        });
    }
    useEffect(function () {
        if (role_idData && role_idData.length > 0) {
            console.log(role_idData, 'role_idData');
        }
    }, [role_idData]);
    // console.log("dataata",form.getValues())
    return (<Form {...form}>
      <FormProvider onSubmit={form.handleSubmit(onSubmit)} className="space-y-8">
        <div style={{ fontWeight: '700', fontSize: "20px" }}>
          {/* <h1>User</h1> */}
        </div>
        <div style={{ display: 'grid', gridTemplateColumns: 'repeat(2, 1fr)', gap: '20px' }}>
          
        <FuzTextField label="Name" name="name" type="text" placeholder="Name" form={form} required/>

          <FuzTextField label="Email" name="email" type="character varying" placeholder="Email" form={form} required/>
          <FuzTextField label="Phone Number" name="phone" type="character varying" placeholder="Phone Number" form={form} required/>
          {!isEdit ? <FuzTextField label="Password" name="password" type="password" placeholder="Password" form={form} pattern="Password"/> : ""}

  
              <FuzSelect label="Role" placeholder="Select Role" required name="role_id" options={role_idData} form={form} displayLabel="name" returnLabel="id"/> 
               {/* <FuzSelect
         label="Role Type"
         placeholder="Role Type"
         required
         name="role_id"
         options={role_idData}
         form={form}
         displayLabel="name"
         returnLabel="id"
       /> */}


          {/* <PhoneNumPicker

          required
          label="mobile_number"
          name="mobile_number"
          form={form}
        />
        <FuzTextField
          label="country_code"
          name="country_code"
          type="character varying"

          placeholder="country_code"



          form={form}

        />

        <FuzTextField
          label="email"
          name="email"
          type="character varying"

          placeholder="email"


          required
          form={form}
          pattern="Email"
        />

        <FuzTextField
          label="password_hash"
          name="password_hash"
          type="password"

          placeholder="password_hash"



          form={form}
          pattern="Password"
        /> */}

        </div>
        <FuzMultiButton submitVariant="default" clearVariant="outline" submitlabel="Submit" clearlabel={isEdit === false ? "Clear" : undefined} submitType="submit" 
    // submitAction={handleSubmit}
    clearAction={function () {
            console.log("form", form);
            form.reset(__assign(__assign({}, defaultValues), { email: '', phone: '' }));
        }} loader={loader}/>
      </FormProvider>
    </Form>);
}
