import { ArrowDownIcon, ArrowUpIcon, CaretSortIcon, } from "@radix-ui/react-icons";
import { cn } from "../../../../lib/utils";
import { Button } from "../../../..//components/ui/button";
import { DropdownMenu, DropdownMenuContent, DropdownMenuItem, DropdownMenuTrigger, } from "../../../../components/ui/dropdown-menu";
export function DataTableColumnHeader(_a) {
    var column = _a.column, title = _a.title, className = _a.className;
    if (!column.getCanSort()) {
        return <div className={cn(className)}>{title}</div>;
    }
    return (<div className={cn("flex items-center space-x-2", className)}>
      <DropdownMenu>
        <DropdownMenuTrigger asChild>
          <Button variant="ghost" size="sm" className="-ml-3 h-8 data-[state=open]:bg-accent">
            <span>{title}</span>
            {column.getIsSorted() === "desc" ? (<ArrowDownIcon className="ml-2 h-4 w-4"/>) : column.getIsSorted() === "asc" ? (<ArrowUpIcon className="ml-2 h-4 w-4"/>) : (<CaretSortIcon className="ml-2 h-4 w-4"/>)}
          </Button>
        </DropdownMenuTrigger>
        <DropdownMenuContent align="start">
          <DropdownMenuItem onClick={function () { return column.toggleSorting(false); }}>
            <ArrowUpIcon className="mr-2 h-3.5 w-3.5 text-muted-foreground/70"/>
            Asc
          </DropdownMenuItem>
          <DropdownMenuItem onClick={function () { return column.toggleSorting(true); }}>
            <ArrowDownIcon className="mr-2 h-3.5 w-3.5 text-muted-foreground/70"/>
            Desc
          </DropdownMenuItem>
        </DropdownMenuContent>
      </DropdownMenu>
    </div>);
}
