"use client";
import { Cross2Icon, PlusIcon } from "@radix-ui/react-icons";
import { useState } from "react";
import { Button } from "../../../../components/ui/button";
import { Input } from "../../../../components/ui/input";
import SideNav from "../components/SideNav";
import { DataTableViewOptions } from "./data-table-view-options";
import { DataTableFacetedFilter } from "./data-table-faceted-filter";
export function DataTableToolbar(_a) {
    var table = _a.table, onRefresh = _a.onRefresh, supabaseAuthAdmin = _a.supabaseAuthAdmin;
    var _b = useState(""), searchValue = _b[0], setSearchValue = _b[1];
    var _c = useState(false), showSideNav = _c[0], setShowSideNav = _c[1];
    var onClose = function () {
        setShowSideNav(false);
    };
    var isFiltered = table.getState().globalFilter != null ||
        table.getState().columnFilters.length > 0;
    var handleSearchChange = function (event) {
        if (event.target.value.trim() != "") {
            setSearchValue(event.target.value);
            table.setGlobalFilter(event.target.value);
        }
        else {
            setSearchValue("");
            table.resetGlobalFilter();
        }
    };
    var status_data = [
        {
            value: "Active",
            label: "Active",
        },
        {
            value: "Inactive",
            label: "Inactive",
        },
        {
            value: "Blocked",
            label: "Blocked",
        },
        {
            value: "Deactivated",
            label: "Deactivated",
        },
    ];
    var resetFilters = function () {
        setSearchValue("");
        table.resetGlobalFilter();
        table.resetColumnFilters();
    };
    console.log("table", table.getColumn("status"));
    return (<div className="flex items-center justify-between">
      <div className="flex flex-1 items-center space-x-2">
        <Input placeholder="Search..." value={searchValue} onChange={handleSearchChange} className="h-8 w-[150px] lg:w-[250px]"/>
        {table.getColumn("status") && (<DataTableFacetedFilter column={table.getColumn("status")} title="status" options={status_data}/>)}


        {isFiltered && (<Button variant="ghost" onClick={resetFilters} className="h-8 px-2 lg:px-3">
            Reset
            <Cross2Icon className="ml-2 h-4 w-4"/>
          </Button>)}
      </div>
      <DataTableViewOptions table={table}/>
      <Button variant="default" size="sm" onClick={function () { return setShowSideNav(true); }} className="h-8 px-2 lg:px-3 ml-4">
        Add
        <PlusIcon className="ml-2 h-4 w-4"/>
      </Button>
      <SideNav onRefresh={onRefresh} setShowSideNav={setShowSideNav} isEdit={false} showSideNav={showSideNav} data={[]} onClose={onClose} supabaseAuthAdmin={supabaseAuthAdmin}/>
    
    </div>);
}
