"use client";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { z } from "zod";
import { useEffect, useState } from "react";
import { columns } from "./components/columns";
import { DataTable } from "./components/data-table";
import { userSchema } from "./data/schema";
import { toast } from "../../../components/ui/use-toast";
// Simulate a database read for tasks.
export function UserList(_a) {
    var _this = this;
    var supabase = _a.supabase, supabaseAuthAdmin = _a.supabaseAuthAdmin;
    var _b = useState([]), listData = _b[0], setListData = _b[1];
    var _c = useState(false), isLoading = _c[0], setIsLoading = _c[1];
    var onEdit = function (value) {
        console.log('done', value);
    };
    var onRefresh = function () { return __awaiter(_this, void 0, void 0, function () {
        var tenants, error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setIsLoading(true);
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, 4, 5]);
                    return [4 /*yield*/, getTenants()];
                case 2:
                    tenants = _a.sent();
                    setListData(tenants);
                    return [3 /*break*/, 5];
                case 3:
                    error_1 = _a.sent();
                    console.error("Error refreshing data:", error_1);
                    return [3 /*break*/, 5];
                case 4:
                    setIsLoading(false);
                    return [7 /*endfinally*/];
                case 5: return [2 /*return*/];
            }
        });
    }); };
    var _d = useState(false), loader = _d[0], setLoader = _d[1];
    useEffect(function () {
        onRefresh(); // Call onRefresh when the component mounts
        setLoader(false);
    }, [loader]);
    var getTenants = function () { return __awaiter(_this, void 0, void 0, function () {
        var _a, users, error;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, supabaseAuthAdmin.auth.admin.listUsers()];
                case 1:
                    _a = _b.sent(), users = _a.data.users, error = _a.error;
                    console.log('tenants', users);
                    if (error) {
                        console.error("Error fetching tenants:", error.message);
                        return [2 /*return*/, []];
                    }
                    else {
                        return [2 /*return*/, z.array(userSchema).parse(users)];
                        // return []
                    }
                    return [2 /*return*/];
            }
        });
    }); };
    var onCallDelete = function (value) {
        console.log('done', value);
        removeUser(value.id);
    };
    var removeUser = function (id) { return __awaiter(_this, void 0, void 0, function () {
        var error;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, supabase.auth.admin.deleteUser(id)];
                case 1:
                    error = (_a.sent()).error;
                    if (error) {
                        console.error("Error fetching tenants:", error.message);
                        toast({
                            title: "You submitted the following values:",
                            description: (<pre className="mt-2 w-[340px] rounded-md bg-slate-950 p-4">
            <code className="text-white">{error.message}</code>
          </pre>),
                        });
                    }
                    else {
                        onRefresh();
                        toast({
                            title: "You submitted the following values:",
                            description: (<pre className="mt-2 w-[340px] rounded-md bg-slate-950 p-4">
            <code className="text-white">Successfully Deleted</code>
          </pre>),
                        });
                        setLoader(true);
                    }
                    return [2 /*return*/];
            }
        });
    }); };
    return (<>
        <DataTable columns={columns({ onEdit: onEdit, onRefresh: onRefresh, onCallDelete: onCallDelete, supabaseAuthAdmin: supabaseAuthAdmin })} supabaseAuthAdmin={supabaseAuthAdmin} data={listData} isLoading={isLoading} onRefresh={onRefresh}/>
      
    </>);
}
