var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { FormControl, FormField, FormItem, FormLabel, FormDescription } from '../../components/ui/form';
import { Checkbox } from '../../components/ui/checkbox';
var ShadowedCheckbox = function (_a) {
    var placeholder = _a.placeholder, required = _a.required, info = _a.info, options = _a.options, label = _a.label, name = _a.name, form = _a.form;
    var errors = form.formState.errors, getValues = form.getValues, setValue = form.setValue;
    // Convert string array to Option array if needed
    var normalizedOptions = (Array.isArray(options) && options.length > 0 && typeof options[0] === 'string')
        ? options.map(function (option) { return ({ id: option, label: option }); })
        : options;
    return (<FormField control={form.control} name={name} render={function (_a) {
            var field = _a.field;
            return (<FormItem>
          <FormControl>
            {options ? (<div>
                <div className="mb-4">
                  <FormLabel className="text-base">{label}</FormLabel>
                  <FormDescription>
                {placeholder}                  </FormDescription>
                </div>
                {normalizedOptions === null || normalizedOptions === void 0 ? void 0 : normalizedOptions.map(function (option) { return (<FormItem key={option.id} className="flex items-center space-x-2">
                    <Checkbox name={"".concat(name, "[").concat(option.id, "]")} checked={Array.isArray(getValues(name)) && getValues(name).includes(option.id)} onCheckedChange={function (checked) {
                            var currentValues = getValues(name) || [];
                            var newItems = checked
                                ? __spreadArray(__spreadArray([], currentValues, true), [option.id], false) : currentValues.filter(function (value) { return value !== option.id; });
                            setValue(name, newItems);
                        }}/>
                    <FormLabel>{option.label}</FormLabel>
                  </FormItem>); })}
              </div>) : (<div className="flex items-center space-x-2">
                <Checkbox name={name} checked={!!field.value} onCheckedChange={field.onChange}/>
                <FormLabel info={info} required={required}>{label}</FormLabel>
              </div>)}
          </FormControl>
          {errors[name] && (<span className="text-red-500">{errors[name].message}</span>)}
        </FormItem>);
        }}/>);
};
export default ShadowedCheckbox;
