"use client";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { FormField, FormItem, FormLabel, FormMessage, FormDescription, } from "../../components/ui/form";
import Select from 'react-select';
import { useFormContext } from 'react-hook-form';
function FuzSelect(_a) {
    var placeholder = _a.placeholder, info = _a.info, label = _a.label, required = _a.required, name = _a.name, description = _a.description, options = _a.options, returnLabel = _a.returnLabel, displayLabel = _a.displayLabel;
    var control = useFormContext().control; // Ensures form control is properly managed by react-hook-form
    // Normalizing options for react-select
    var normalizedOptions = options.map(function (option) { return (__assign(__assign({}, option), { value: option && returnLabel ? option[returnLabel] : option, label: option && displayLabel ? option[displayLabel] : option })); });
    // Function to find an option by value
    var findOptionByValue = function (value) { return normalizedOptions.find(function (opt) { return opt.value === value; }); };
    return (<FormField control={control} name={name} render={function (_a) {
            var field = _a.field;
            return (<FormItem>
                    <FormLabel info={info} required={required}>{label}</FormLabel>
                    <Select options={normalizedOptions} onChange={function (selectedOption) { return field.onChange(selectedOption ? selectedOption.value : ''); }} value={findOptionByValue(field.value)} placeholder={placeholder} className="react-select-container" classNamePrefix="react-select"/>
                    <FormDescription>{description}</FormDescription>
                    <FormMessage />
                </FormItem>);
        }}/>);
}
export default FuzSelect;
