var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { useEffect, useState } from 'react';
import { Upload } from 'antd';
import ImgCrop from 'antd-img-crop';
import { FormField, FormItem, FormLabel, FormMessage, } from "../../components/ui/form";
import supabase from "../../components/utils/supabaseClient";
import IMAGE_BASE_URL from '../../components/utils/config-global';
var ImageUploader = function (_a) {
    var _b = _a.listType, listType = _b === void 0 ? 'picture-card' : _b, 
    //   onUploadChange,
    name = _a.name, form = _a.form, label = _a.label, required = _a.required, info = _a.info, _c = _a.multiple, multiple = _c === void 0 ? 1 : _c, _d = _a.maxSize, maxSize = _d === void 0 ? 3 : _d;
    var _e = useState([]), fileList = _e[0], setFileList = _e[1];
    useEffect(function () {
        var fileValues = form.getValues(name); // This should return an array of URLs
        if (fileValues && (fileList === null || fileList === void 0 ? void 0 : fileList.length) === 0) {
            var newFileList = fileValues.map(function (item, index) { return ({
                uid: index.toString(),
                name: item,
                status: 'done',
                url: item,
            }); });
            setFileList(newFileList);
        }
    }, [form.getValues(name)]);
    var onChange = function (_a) { return __awaiter(void 0, [_a], void 0, function (_b) {
        var file, contentType, currentTimestamp, fileExtension, fileName, _c, data, error, newFileData_1, previousValue, updatedValue, err_1;
        var _d, _e, _f, _g;
        var newFileList = _b.fileList;
        return __generator(this, function (_h) {
            switch (_h.label) {
                case 0:
                    if (!((newFileList === null || newFileList === void 0 ? void 0 : newFileList.length) !== 0 && ((_d = newFileList[(newFileList === null || newFileList === void 0 ? void 0 : newFileList.length) - 1]) === null || _d === void 0 ? void 0 : _d.originFileObj))) return [3 /*break*/, 4];
                    file = (_e = newFileList[(newFileList === null || newFileList === void 0 ? void 0 : newFileList.length) - 1]) === null || _e === void 0 ? void 0 : _e.originFileObj;
                    contentType = ((_f = file === null || file === void 0 ? void 0 : file.name) === null || _f === void 0 ? void 0 : _f.endsWith('.png')) ? 'image/png' : 'image/jpeg';
                    _h.label = 1;
                case 1:
                    _h.trys.push([1, 3, , 4]);
                    currentTimestamp = Date.now();
                    fileExtension = file.name.split('.').pop();
                    fileName = "".concat(currentTimestamp, ".").concat(fileExtension);
                    return [4 /*yield*/, supabase.storage
                            .from('images')
                            .upload("temp/" + fileName, file, {
                            contentType: contentType
                        })];
                case 2:
                    _c = _h.sent(), data = _c.data, error = _c.error;
                    if (data) {
                        newFileData_1 = {
                            uid: (_g = newFileList[(newFileList === null || newFileList === void 0 ? void 0 : newFileList.length) - 1]) === null || _g === void 0 ? void 0 : _g.uid,
                            name: (data === null || data === void 0 ? void 0 : data.fullPath) || '',
                            status: 'done',
                            url: "".concat(IMAGE_BASE_URL).concat(data === null || data === void 0 ? void 0 : data.fullPath),
                        };
                        if (multiple === 1) {
                            form.setValue(name, ["".concat(IMAGE_BASE_URL).concat(data.fullPath)]);
                            setFileList([newFileData_1]);
                            form.clearErrors(name);
                        }
                        else {
                            previousValue = form.getValues(name) || [];
                            updatedValue = __spreadArray(__spreadArray([], previousValue, true), ["".concat(IMAGE_BASE_URL).concat(data.fullPath)], false);
                            form.setValue(name, updatedValue);
                            setFileList(function (prevFileList) { return __spreadArray(__spreadArray([], prevFileList, true), [newFileData_1], false); });
                            form.clearErrors(name);
                        }
                    }
                    else {
                        console.error('Error uploading image:', error);
                    }
                    return [3 /*break*/, 4];
                case 3:
                    err_1 = _h.sent();
                    console.error('Error uploading image:', err_1);
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    }); };
    var onRemove = function (file) { return __awaiter(void 0, void 0, void 0, function () {
        var newFileList, error, err_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    newFileList = fileList.filter(function (item) { return item.uid !== file.uid; });
                    setFileList(newFileList);
                    form.setValue(name, newFileList.map(function (f) { return f.url; }));
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, supabase.storage
                            .from('images')
                            .remove([file.name])];
                case 2:
                    error = (_a.sent()).error;
                    if (error) {
                        throw error;
                    }
                    return [3 /*break*/, 4];
                case 3:
                    err_2 = _a.sent();
                    console.error('Failed to delete image:', err_2);
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    }); };
    var onPreview = function (file) { return __awaiter(void 0, void 0, void 0, function () {
        var src, image, imgWindow;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    src = file.url;
                    if (!!src) return [3 /*break*/, 2];
                    return [4 /*yield*/, new Promise(function (resolve) {
                            var reader = new FileReader();
                            reader.readAsDataURL(file.originFileObj);
                            reader.onload = function () { return resolve(reader.result); };
                        })];
                case 1:
                    src = _a.sent();
                    _a.label = 2;
                case 2:
                    image = new Image();
                    image.src = src;
                    imgWindow = window.open(src);
                    imgWindow === null || imgWindow === void 0 ? void 0 : imgWindow.document.write(image.outerHTML);
                    return [2 /*return*/];
            }
        });
    }); };
    return (<FormField control={form.control} name={name} render={function () { return (<FormItem className="flex flex-col">
          <FormLabel info={info} required={required}>{label}</FormLabel>
          <ImgCrop>
            <Upload 
        // action={action}
        listType={listType} fileList={fileList} onChange={onChange} onPreview={onPreview} maxCount={multiple} onRemove={onRemove} beforeUpload={function (file) {
                var isLessThan3MB = file.size / 1024 / 1024 < maxSize;
                // if (!isLessThan3MB) {
                //   message.error('Image must be smaller than 3MB!');
                // }
                return isLessThan3MB;
            }}>
              {fileList.length < multiple && '+ Upload'}
            </Upload>
          </ImgCrop>
          {/* <FormDescription>
              {placeholder}
            </FormDescription> */}
          <FormMessage />
        </FormItem>); }}/>);
};
export default ImageUploader;
