// ShadowedRadioGroup.tsx
import React from 'react';
import { useFormContext } from 'react-hook-form';
import { FormField, FormItem, FormLabel, FormMessage } from "../../components/ui/form";
import { RadioGroup, RadioGroupItem } from "../../components/ui/radio-group";
var ShadowedRadioGroup = function (_a) {
    var info = _a.info, required = _a.required, options = _a.options, label = _a.label, name = _a.name, form = _a.form;
    var setValue = useFormContext().setValue;
    // Normalize options to always be an array of Option objects
    var normalizedOptions = (options || []).map(function (option) {
        if (typeof option === 'string') {
            // If it's a string, use it for both label and value
            return { label: option, value: option };
        }
        // If it's already an Option object, just return it
        return option;
    });
    // Set the default selected value based on `field.value`
    React.useEffect(function () {
        setValue(name, form.watch(name));
    }, [setValue, name, form]);
    return (<FormField control={form.control} name={name} render={function (_a) {
            var field = _a.field;
            return (<FormItem className="space-y-3">
          <FormLabel info={info} required={required}>{label}</FormLabel>
          <RadioGroup onValueChange={field.onChange} value={field.value} className="flex flex-col space-y-1">
            {normalizedOptions === null || normalizedOptions === void 0 ? void 0 : normalizedOptions.map(function (option) { return (<FormItem key={option.value} className="flex items-center space-x-3 space-y-0">
                <RadioGroupItem value={option.value}/>
                <FormLabel className="font-normal">{option.label}</FormLabel>
              </FormItem>); })}
          </RadioGroup>
          <FormMessage />
        </FormItem>);
        }}/>);
};
export default ShadowedRadioGroup;
