var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as React from "react";
import { cn } from "../../lib/utils";
var Input = React.forwardRef(function (_a, ref) {
    var className = _a.className, type = _a.type, props = __rest(_a, ["className", "type"]);
    var selectedValidationType = type || 'text';
    // const selectedValidationType = props?.pattern?"pattern": 'text';
    var handleInputChange = function (e) {
        var inputValue = e.target.value;
        var filteredValue = inputValue;
        console.log("maxLength", props, filteredValue);
        switch (selectedValidationType) {
            case 'text':
                filteredValue = inputValue.replace(props === null || props === void 0 ? void 0 : props.pattern, '').slice(0, (props === null || props === void 0 ? void 0 : props.maxLength) || 250);
                break;
            case 'string':
                filteredValue = inputValue.replace(props === null || props === void 0 ? void 0 : props.pattern, '').slice(0, (props === null || props === void 0 ? void 0 : props.maxLength) || 250);
                break;
            case 'number':
                filteredValue = parseInt(inputValue.replace(/[^0-9]/g, '').slice(0, (props === null || props === void 0 ? void 0 : props.maxLength) || 250));
                break;
            case 'decimal':
                filteredValue = inputValue.replace(/[^0-9.]/g, ''); // Allow only numeric characters and dot
                var dotIndex = filteredValue.indexOf('.');
                if (dotIndex !== -1) {
                    var parts = filteredValue.split('.');
                    filteredValue = parts[0] + '.' + parts[1].slice(0, 2); // Restrict to two characters after the dot
                }
                break;
            default:
                filteredValue = inputValue.slice(0, (props === null || props === void 0 ? void 0 : props.maxLength) || 250);
                break;
        }
        e.target.value = filteredValue;
    };
    return (<input type={type} className={cn("flex h-10 w-full rounded-md border border-input bg-background px-3 py-2 text-sm ring-offset-background file:border-0 file:bg-transparent file:text-sm file:font-medium placeholder:text-muted-foreground focus-visible:outline-none focus-visible:ring-2 focus-visible:ring-ring focus-visible:ring-offset-2 disabled:cursor-not-allowed disabled:opacity-50", className)} ref={ref} onInput={handleInputChange} {...props}/>);
});
Input.displayName = "Input";
export { Input };
