var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { forwardRef, useEffect, useState } from "react";
import PhoneInput from 'react-phone-input-2';
import 'react-phone-input-2/lib/style.css';
import { useFormContext } from 'react-hook-form';
var MyPhonePicker = forwardRef(function (props) {
    var inputProps = props.inputProps, name = props.name, _a = props.initialCountry, initialCountry = _a === void 0 ? 'in' : _a, defaultValues = props.defaultValues;
    var _b = useFormContext(), setValue = _b.setValue, clearErrors = _b.clearErrors, isSubmitted = _b.formState.isSubmitted;
    var _c = useState(''), phoneValue = _c[0], setPhoneValue = _c[1];
    var _d = useState(false), formValue = _d[0], setFormValues = _d[1];
    var handleChange = function (value, data) {
        var dotCount = (data.format.match(/\./g) || []).length;
        var tempDotCount = dotCount <= 15 ? dotCount : 15;
        var countryCode = data.dialCode.replace(/[^0-9]/g, '');
        setPhoneValue(value);
        if (tempDotCount === (value === null || value === void 0 ? void 0 : value.length)) {
            setValue(name, value);
            clearErrors(name);
        }
        else {
            setValue(name, countryCode);
        }
    };
    useEffect(function () {
        if (isSubmitted) {
            setFormValues(true);
        }
        if (!isSubmitted && formValue) {
            setFormValues(false);
            setPhoneValue('91');
        }
    }, [isSubmitted]);
    return (<PhoneInput country={initialCountry} value={defaultValues ? defaultValues : phoneValue} countryCodeEditable={false} 
    // {...rest}
    inputProps={__assign(__assign({}, inputProps), { className: 'phone-input', 
            // required: true,
            // onInvalid: (e: { target: { setCustomValidity: (arg0: string) => any; }; }) => e.target.setCustomValidity('Please enter your phone number.'),
            // onInput: (e: { target: { setCustomValidity: (arg0: string) => any; }; }) => e.target.setCustomValidity(''),
            placeholder: 'Enter phone number', style: {
                width: '100%',
                fontSize: '15px',
                padding: '0.5rem 2.75rem 0.5rem 2.75rem',
                borderRadius: '5px',
                border: '1px solid #e5e7eb'
            } })} onChange={handleChange}/>);
});
MyPhonePicker.displayName = "MyPhonePicker";
export default MyPhonePicker;
