import Select from 'react-select';
import { useFormContext } from 'react-hook-form';
var SingleSelect = function (_a) {
    var name = _a.name, options = _a.options, placeholder = _a.placeholder, showOption = _a.showOption, getByValue = _a.getByValue;
    var setValue = useFormContext().setValue;
    var handleSelect = function (selectedOption) {
        if (typeof selectedOption === "object" && getByValue) {
            var value = selectedOption.value[getByValue];
            setValue(name, value);
        }
        else {
            var value = selectedOption.value;
            setValue(name, value);
        }
    };
    return (<div className="flex items-center space-x-2 relative">
            <Select options={options.map(function (item) {
            if (typeof item === 'object' && showOption !== undefined && showOption in item) {
                return {
                    label: item[showOption],
                    value: item
                };
            }
            else {
                return {
                    label: item,
                    value: item
                };
            }
        })} className="w-full" onChange={handleSelect} placeholder={placeholder}/>            
        </div>);
};
export { SingleSelect }; // Make sure to export the component
