import { TimePicker } from 'antd';
import dayjs from 'dayjs'; // Import dayjs and Dayjs if not already imported
import moment from "moment";
var TimeRange = function (_a) {
    var minTime = _a.minTime, maxTime = _a.maxTime, _b = _a.dateFieldName, dateFieldName = _b === void 0 ? 'defaultFieldName' : _b, defaultValue = _a.defaultValue;
    var selectedDefaultValue = defaultValue === null || defaultValue === void 0 ? void 0 : defaultValue[dateFieldName];
    // Convert start and end times to dayjs objects
    var defaultStartDate = (selectedDefaultValue === null || selectedDefaultValue === void 0 ? void 0 : selectedDefaultValue.startTime) ? dayjs(selectedDefaultValue.startTime, 'HH:mm:ss') : dayjs();
    var defaultEndDate = (selectedDefaultValue === null || selectedDefaultValue === void 0 ? void 0 : selectedDefaultValue.endTime) ? dayjs(selectedDefaultValue.endTime, 'HH:mm:ss') : dayjs();
    var minimumTime = moment(minTime, 'h:mm A');
    var maximumTime = moment(maxTime, 'h:mm A');
    var disabledHours = function () {
        var hours = []; // Explicitly type the array as number[]
        var minHour = Number(minimumTime.hour());
        var maxHour = Number(maximumTime.hour());
        for (var i = 0; i < 24; i++) {
            if (i < minHour || i > maxHour) {
                hours.push(i);
            }
        }
        return hours;
    };
    var disabledMinutes = function (selectedHour) {
        if (selectedHour === minimumTime.hour()) {
            var minutes = []; // Explicitly type the array as number[]
            for (var i = 0; i < 60; i++) {
                if (i < minimumTime.minute()) {
                    minutes.push(i);
                }
            }
            return minutes;
        }
        else if (selectedHour === maximumTime.hour()) {
            var minutes = []; // Explicitly type the array as number[]
            for (var i = 0; i < 60; i++) {
                if (i > maximumTime.minute()) {
                    minutes.push(i);
                }
            }
            return minutes;
        }
        return [];
    };
    var disabledSeconds = function (selectedHour, selectedMinute) {
        var seconds = []; // Explicitly type the array as number[]
        var minSecond = Number(minimumTime.second());
        var maxSecond = Number(maximumTime.second());
        if (selectedHour === minimumTime.hour() && selectedMinute === minimumTime.minute()) {
            for (var i = 0; i < 60; i++) {
                if (i < minSecond) {
                    seconds.push(i);
                }
            }
        }
        else if (selectedHour === maximumTime.hour() && selectedMinute === maximumTime.minute()) {
            for (var i = 0; i < 60; i++) {
                if (i > maxSecond) {
                    seconds.push(i);
                }
            }
        }
        return seconds;
    };
    var handleRangeChange = function (_dates) {
        // setRange(dates);
        console.log("testing");
    };
    return (<TimePicker.RangePicker defaultValue={[defaultStartDate, defaultEndDate]} 
    // value={range}
    onChange={function () { return handleRangeChange; }} disabledHours={disabledHours} disabledMinutes={disabledMinutes} disabledSeconds={disabledSeconds}/>);
};
export default TimeRange;
