var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { useEffect, useRef, useState } from 'react';
import { VIEWS, } from 'pasubot-auth-ui-shared';
import { Anchor, Button, Container, Input, Label, Message, } from '../../UI/index.js';
function EmailAuth(_a) {
    var _this = this;
    var _b, _c, _d, _e;
    var _f = _a.authView, authView = _f === void 0 ? 'sign_in' : _f, _g = _a.defaultEmail, defaultEmail = _g === void 0 ? '' : _g, _h = _a.defaultPassword, defaultPassword = _h === void 0 ? '' : _h, _j = _a.setAuthView, setAuthView = _j === void 0 ? function () { } : _j, _k = _a.setDefaultEmail, setDefaultEmail = _k === void 0 ? function (email) { } : _k, _l = _a.setDefaultPassword, setDefaultPassword = _l === void 0 ? function (password) { } : _l, supabaseClient = _a.supabaseClient, _m = _a.showLinks, showLinks = _m === void 0 ? false : _m, redirectTo = _a.redirectTo, additionalData = _a.additionalData, magicLink = _a.magicLink, i18n = _a.i18n, appearance = _a.appearance, _o = _a.passwordLimit, passwordLimit = _o === void 0 ? false : _o, children = _a.children;
    var isMounted = useRef(true);
    var _p = useState(defaultEmail), email = _p[0], setEmail = _p[1];
    var _q = useState(defaultPassword), password = _q[0], setPassword = _q[1];
    var _r = useState(''), error = _r[0], setError = _r[1];
    var _s = useState(false), loading = _s[0], setLoading = _s[1];
    var _t = useState(''), message = _t[0], setMessage = _t[1];
    useEffect(function () {
        isMounted.current = true;
        setEmail(defaultEmail);
        setPassword(defaultPassword);
        return function () {
            isMounted.current = false;
        };
    }, [authView]);
    var handleSubmit = function (e) { return __awaiter(_this, void 0, void 0, function () {
        var _a, signInError, options, _b, _c, signUpUser, signUpSession, signUpError;
        var _d;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    e.preventDefault();
                    setError('');
                    setLoading(true);
                    _a = authView;
                    switch (_a) {
                        case 'sign_in': return [3 /*break*/, 1];
                        case 'sign_up': return [3 /*break*/, 3];
                    }
                    return [3 /*break*/, 5];
                case 1: return [4 /*yield*/, supabaseClient.auth.signInWithPassword({
                        email: email,
                        password: password,
                    })];
                case 2:
                    signInError = (_e.sent()).error;
                    if (signInError)
                        setError(signInError.message);
                    return [3 /*break*/, 5];
                case 3:
                    if (passwordLimit && password.length > 72) {
                        setError('Password exceeds maxmium length of 72 characters');
                        return [2 /*return*/];
                    }
                    options = {
                        emailRedirectTo: redirectTo,
                    };
                    if (additionalData) {
                        options.data = additionalData;
                    }
                    return [4 /*yield*/, supabaseClient.auth.signUp({
                            email: email,
                            password: password,
                            options: options,
                        })];
                case 4:
                    _b = _e.sent(), _c = _b.data, signUpUser = _c.user, signUpSession = _c.session, signUpError = _b.error;
                    if (signUpError)
                        setError(signUpError.message);
                    // Check if session is null -> email confirmation setting is turned on
                    else if (signUpUser && !signUpSession)
                        setMessage((_d = i18n === null || i18n === void 0 ? void 0 : i18n.sign_up) === null || _d === void 0 ? void 0 : _d.confirmation_text);
                    return [3 /*break*/, 5];
                case 5:
                    /*
                     * it is possible the auth component may have been unmounted at this point
                     * check if component is mounted before setting a useState
                     */
                    if (isMounted.current)
                        setLoading(false);
                    return [2 /*return*/];
            }
        });
    }); };
    var handleViewChange = function (newView) {
        setDefaultEmail(email);
        setDefaultPassword(password);
        setAuthView(newView);
    };
    var labels = i18n === null || i18n === void 0 ? void 0 : i18n[authView];
    return (<form id={authView === 'sign_in' ? "auth-sign-in" : "auth-sign-up"} onSubmit={handleSubmit} autoComplete={'on'} style={{ width: '100%' }}>
      <Container direction="vertical" gap="large" appearance={appearance}>
        <Container direction="vertical" gap="large" appearance={appearance}>
          <div>
            <Label htmlFor="email" appearance={appearance}>
              {labels === null || labels === void 0 ? void 0 : labels.email_label}
            </Label>
            <Input id="email" type="email" name="email" placeholder={labels === null || labels === void 0 ? void 0 : labels.email_input_placeholder} defaultValue={email} onChange={function (e) {
            return setEmail(e.target.value);
        }} autoComplete="email" appearance={appearance}/>
          </div>
          <div>
            <Label htmlFor="password" appearance={appearance}>
              {labels === null || labels === void 0 ? void 0 : labels.password_label}
            </Label>
            <Input id="password" type="password" name="password" placeholder={labels === null || labels === void 0 ? void 0 : labels.password_input_placeholder} defaultValue={password} onChange={function (e) {
            return setPassword(e.target.value);
        }} autoComplete={authView === 'sign_in' ? 'current-password' : 'new-password'} appearance={appearance}/>
          </div>
          {children}
        </Container>

        <Button type="submit" color="primary" loading={loading} appearance={appearance}>
          {loading ? labels === null || labels === void 0 ? void 0 : labels.loading_button_label : labels === null || labels === void 0 ? void 0 : labels.button_label}
        </Button>

        {showLinks && (<Container direction="vertical" gap="small" appearance={appearance}>
            {authView === VIEWS.SIGN_IN && magicLink && (<Anchor href="#auth-magic-link" onClick={function (e) {
                    e.preventDefault();
                    setAuthView(VIEWS.MAGIC_LINK);
                }} appearance={appearance}>
                {(_b = i18n === null || i18n === void 0 ? void 0 : i18n.magic_link) === null || _b === void 0 ? void 0 : _b.link_text}
              </Anchor>)}
            {authView === VIEWS.SIGN_IN && (<Anchor href="#auth-forgot-password" onClick={function (e) {
                    e.preventDefault();
                    setAuthView(VIEWS.FORGOTTEN_PASSWORD);
                }} appearance={appearance}>
                {(_c = i18n === null || i18n === void 0 ? void 0 : i18n.forgotten_password) === null || _c === void 0 ? void 0 : _c.link_text}
              </Anchor>)}
            {authView === VIEWS.SIGN_IN ? (<Anchor href="#auth-sign-up" onClick={function (e) {
                    e.preventDefault();
                    handleViewChange(VIEWS.SIGN_UP);
                }} appearance={appearance}>
                {(_d = i18n === null || i18n === void 0 ? void 0 : i18n.sign_up) === null || _d === void 0 ? void 0 : _d.link_text}
              </Anchor>) : (<Anchor href="#auth-sign-in" onClick={function (e) {
                    e.preventDefault();
                    handleViewChange(VIEWS.SIGN_IN);
                }} appearance={appearance}>
                {(_e = i18n === null || i18n === void 0 ? void 0 : i18n.sign_in) === null || _e === void 0 ? void 0 : _e.link_text}
              </Anchor>)}
          </Container>)}
      </Container>
      {message && <Message appearance={appearance}>{message}</Message>}
      {error && (<Message color="danger" appearance={appearance}>
          {error}
        </Message>)}
    </form>);
}
export { EmailAuth };
