var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { useState } from 'react';
import { Button, Container, Input, Label, Message } from '../../UI/index.js';
function UpdatePassword(_a) {
    var _this = this;
    var supabaseClient = _a.supabaseClient, i18n = _a.i18n, appearance = _a.appearance, _b = _a.passwordLimit, passwordLimit = _b === void 0 ? false : _b;
    var _c = useState(''), password = _c[0], setPassword = _c[1];
    var _d = useState(''), error = _d[0], setError = _d[1];
    var _e = useState(''), message = _e[0], setMessage = _e[1];
    var _f = useState(false), loading = _f[0], setLoading = _f[1];
    var handlePasswordReset = function (e) { return __awaiter(_this, void 0, void 0, function () {
        var error;
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    e.preventDefault();
                    setError('');
                    setMessage('');
                    setLoading(true);
                    if (passwordLimit && password.length > 72) {
                        setError('Password exceeds maxmium length of 72 characters');
                        setLoading(false);
                        return [2 /*return*/];
                    }
                    return [4 /*yield*/, supabaseClient.auth.updateUser({ password: password })];
                case 1:
                    error = (_b.sent()).error;
                    if (error)
                        setError(error.message);
                    else
                        setMessage((_a = i18n === null || i18n === void 0 ? void 0 : i18n.update_password) === null || _a === void 0 ? void 0 : _a.confirmation_text);
                    setLoading(false);
                    return [2 /*return*/];
            }
        });
    }); };
    var labels = i18n === null || i18n === void 0 ? void 0 : i18n.update_password;
    return (<form id="auth-update-password" onSubmit={handlePasswordReset}>
      <Container gap="large" direction={'vertical'} appearance={appearance}>
        <div>
          <Label htmlFor="password" appearance={appearance}>
            {labels === null || labels === void 0 ? void 0 : labels.password_label}
          </Label>
          <Input id="password" name="password" placeholder={labels === null || labels === void 0 ? void 0 : labels.password_input_placeholder} type="password" autoFocus onChange={function (e) {
            return setPassword(e.target.value);
        }} appearance={appearance}/>
        </div>
        <Button type="submit" color="primary" loading={loading} appearance={appearance}>
          {loading ? labels === null || labels === void 0 ? void 0 : labels.loading_button_label : labels === null || labels === void 0 ? void 0 : labels.button_label}
        </Button>
        {message && <Message appearance={appearance}>{message}</Message>}
        {error && (<Message color="danger" appearance={appearance}>
            {error}
          </Message>)}
      </Container>
    </form>);
}
export { UpdatePassword };
