var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { useState } from 'react';
import { VIEWS } from 'pasubot-auth-ui-shared';
import { Anchor, Button, Container, Input, Label, Message, } from '../../UI/index.js';
function VerifyOtp(_a) {
    var _this = this;
    var _b;
    var _c = _a.setAuthView, setAuthView = _c === void 0 ? function () { } : _c, supabaseClient = _a.supabaseClient, _d = _a.otpType, otpType = _d === void 0 ? 'email' : _d, i18n = _a.i18n, appearance = _a.appearance, _e = _a.showLinks, showLinks = _e === void 0 ? false : _e;
    var _f = useState(''), email = _f[0], setEmail = _f[1];
    var _g = useState(''), phone = _g[0], setPhone = _g[1];
    var _h = useState(''), token = _h[0], setToken = _h[1];
    var _j = useState(''), error = _j[0], setError = _j[1];
    var _k = useState(''), message = _k[0], setMessage = _k[1];
    var _l = useState(false), loading = _l[0], setLoading = _l[1];
    var handleSubmit = function (e) { return __awaiter(_this, void 0, void 0, function () {
        var verifyOpts, error;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    e.preventDefault();
                    setError('');
                    setMessage('');
                    setLoading(true);
                    verifyOpts = {
                        email: email,
                        token: token,
                        type: otpType,
                    };
                    if (['sms', 'phone_change'].includes(otpType)) {
                        verifyOpts = {
                            phone: phone,
                            token: token,
                            type: otpType,
                        };
                    }
                    return [4 /*yield*/, supabaseClient.auth.verifyOtp(verifyOpts)];
                case 1:
                    error = (_a.sent()).error;
                    if (error)
                        setError(error.message);
                    setLoading(false);
                    return [2 /*return*/];
            }
        });
    }); };
    var labels = i18n === null || i18n === void 0 ? void 0 : i18n.verify_otp;
    return (<form id="auth-magic-link" onSubmit={handleSubmit}>
      <Container gap="large" direction="vertical" appearance={appearance}>
        {['sms', 'phone_change'].includes(otpType) ? (<div>
            <Label htmlFor="phone" appearance={appearance}>
              {labels === null || labels === void 0 ? void 0 : labels.phone_input_label}
            </Label>
            <Input id="phone" name="phone" type="text" autoFocus placeholder={labels === null || labels === void 0 ? void 0 : labels.phone_input_placeholder} onChange={function (e) {
                return setPhone(e.target.value);
            }} appearance={appearance}/>
          </div>) : (<div>
            <Label htmlFor="email" appearance={appearance}>
              {labels === null || labels === void 0 ? void 0 : labels.email_input_label}
            </Label>
            <Input id="email" name="email" type="email" autoFocus placeholder={labels === null || labels === void 0 ? void 0 : labels.email_input_placeholder} onChange={function (e) {
                return setEmail(e.target.value);
            }} appearance={appearance}/>
          </div>)}
        <div>
          <Label htmlFor="token" appearance={appearance}>
            {labels === null || labels === void 0 ? void 0 : labels.token_input_label}
          </Label>
          <Input id="token" name="token" type="text" placeholder={labels === null || labels === void 0 ? void 0 : labels.token_input_placeholder} onChange={function (e) {
            return setToken(e.target.value);
        }} appearance={appearance}/>
        </div>
        <Button color="primary" type="submit" loading={loading} appearance={appearance}>
          {loading ? labels === null || labels === void 0 ? void 0 : labels.loading_button_label : labels === null || labels === void 0 ? void 0 : labels.button_label}
        </Button>
        {showLinks && (<Anchor href="#auth-sign-in" onClick={function (e) {
                e.preventDefault();
                setAuthView(VIEWS.SIGN_IN);
            }} appearance={appearance}>
            {(_b = i18n === null || i18n === void 0 ? void 0 : i18n.sign_in) === null || _b === void 0 ? void 0 : _b.link_text}
          </Anchor>)}
        {message && <Message appearance={appearance}>{message}</Message>}
        {error && (<Message color="danger" appearance={appearance}>
            {error}
          </Message>)}
      </Container>
    </form>);
}
export { VerifyOtp };
