import Auth from '../Auth';
import { PREPENDED_CLASS_NAMES } from 'pasubot-auth-ui-shared';
import { css } from '@stitches/core';
var containerDefaultStyles = css({
    borderRadius: '12px',
    boxShadow: 'rgba(100, 100, 111, 0.2) 0px 7px 29px 0px',
    width: '360px',
    padding: '28px 32px',
});
export var AuthCard = function (_a) {
    var children = _a.children, appearance = _a.appearance;
    var classNames = [
        "".concat(PREPENDED_CLASS_NAMES, "_ui-card"),
        containerDefaultStyles(),
        appearance === null || appearance === void 0 ? void 0 : appearance.className,
    ];
    return <div className={classNames.join(' ')}>{children}</div>;
};
export var SignUp = function (props) {
    return (<Auth showLinks={false} {...props} onlyThirdPartyProviders={false} view="sign_up"/>);
};
export var SignIn = function (props) {
    return (<Auth showLinks={false} {...props} onlyThirdPartyProviders={false} view="sign_in"/>);
};
export var MagicLink = function (props) {
    return <Auth {...props} view="magic_link" showLinks={false}/>;
};
export var SocialAuth = function (props) {
    return (<Auth {...props} view="sign_in" showLinks={false} onlyThirdPartyProviders={true}/>);
};
export var ForgottenPassword = function (props) {
    return <Auth showLinks={false} {...props} view="forgotten_password"/>;
};
export var UpdatePassword = function (props) {
    return <Auth {...props} view="update_password"/>;
};
export var VerifyOtp = function (props) {
    return <Auth {...props} view="verify_otp"/>;
};
