"use client";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { useState, useEffect } from 'react';
export function RolesList(_a) {
    var _this = this;
    var supabase = _a.supabase;
    // State for managing side menu visibility
    var _b = useState(false), showSideMenu = _b[0], setShowSideMenu = _b[1];
    // State for managing form data
    var _c = useState({
        name: '', // Initialize with empty string
        description: '', // Initialize with empty string
        type: '', // Initialize with empty string
        is_default: false,
        id: "",
        access_level: undefined
    }), formData = _c[0], setFormData = _c[1];
    // State for managing roles
    var _d = useState([]), roles = _d[0], setRoles = _d[1]; // Define the state type as Role[]
    useEffect(function () {
        console.log("ROLE LIST REACHED");
        fetchRoles();
    }, []);
    function fetchRoles() {
        return __awaiter(this, void 0, void 0, function () {
            var _a, data, error, error_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, supabase.auth.rolesList()];
                    case 1:
                        _a = _b.sent(), data = _a.data, error = _a.error;
                        console.log("ROLE LIST REACHED", data);
                        if (error) {
                            throw error;
                        }
                        if (data) {
                            setRoles(data.role.roles);
                        }
                        return [3 /*break*/, 3];
                    case 2:
                        error_1 = _b.sent();
                        console.error('Error fetching roles:', error_1);
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    }
    // Function to handle opening side menu
    var handleOpenSideMenu = function () {
        setShowSideMenu(true);
    };
    // Function to handle closing side menu
    var handleCloseSideMenu = function () {
        setShowSideMenu(false);
    };
    // Function to handle form input changes
    var handleInputChange = function (e) {
        var _a = e.target, name = _a.name, value = _a.value;
        setFormData(function (prevState) {
            var _a;
            return (__assign(__assign({}, prevState), (_a = {}, _a[name] = value // Accessing dynamic property based on input name
            , _a)));
        });
    };
    // Function to handle saving role
    var handleSaveRole = function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: 
                // Add the formData to the roles array
                return [4 /*yield*/, supabase.auth.createRole(formData)];
                case 1:
                    // Add the formData to the roles array
                    _a.sent();
                    return [4 /*yield*/, fetchRoles()
                        // Reset form data
                    ];
                case 2:
                    _a.sent();
                    // Reset form data
                    setFormData({
                        name: '', // Reset to empty string
                        description: '', // Reset to empty string
                        type: '', // Reset to empty string
                        is_default: false,
                        id: "",
                        access_level: undefined
                    });
                    // Close side menu
                    setShowSideMenu(false);
                    return [2 /*return*/];
            }
        });
    }); };
    var handleChange = function (event) {
        setFormData(__assign(__assign({}, formData), { type: event.target.value }));
    };
    return (<div className="container">
      <div className="container">
        <div className="button-container">
          <h3><strong>Roles List</strong></h3>
          <button className="add-button" onClick={handleOpenSideMenu}>Add Role</button>
        </div>
        <table className="custom-table">
          <thead>
            <tr>
              <th>Name</th>
              <th>Status</th>
              <th>Type</th>
              <th>Select</th>
            </tr>
          </thead>
          <tbody>
            {roles.map(function (role, index) { return (<tr key={index}>
                <td>{role.name}</td>
                <td>{role.status}</td>
                <td>{role.privilege_type}</td>
                <td><input type="checkbox"/></td>
              </tr>); })}
          </tbody>
        </table>
        {showSideMenu && (<div className="side-menu">
            <div className="header-container">
              <h3><strong>Create Role</strong></h3>
              <button className="cancel-button" onClick={handleCloseSideMenu}>Cancel</button>
            </div>
            <form>
              <label>Name:</label>
              <input type="text" name="name" value={formData.name} onChange={handleInputChange}/>
              <label>Description</label>
              <input type="text" name="description" value={formData.description} onChange={handleInputChange}/>
              <label>Role Type:</label>
              <select name="roleType" value={formData.type} onChange={handleChange}>
                <option value="">Select role type</option>
                {roles.map(function (role) { return (<option key={role.name} value={role.name}>{role.name}</option>); })}
              </select>
              <button type="button" onClick={handleSaveRole}>Save</button>
            </form>

          </div>)}
        <style>{"\n        .container {\n          padding: 20px;\n        }\n        .custom-table {\n          width: 100%;\n          border-collapse: collapse;\n          margin-top: 10px;\n          \n        }\n        .custom-table th, .custom-table td {\n          border: 1px solid #ddd;\n          padding: 8px;\n        }\n        .button-container {\n            display: flex;\n            justify-content: flex-end;\n            justify-content: space-between;\n          }\n          .header-container {\n            display: flex;\n            align-items: center;\n            justify-content: space-between; /* Adjust if you want space between the elements */\n          }\n        .add-button {\n          margin-bottom: 20px;\n          background-color: #000000;\n          color: #fff;\n          border: none;\n          padding: 10px 20px;\n          border-radius: 5px;\n          cursor: pointer;\n        }\n        .add-button:hover {\n          background-color: #000000;\n        }\n        .side-menu {\n            margin-top: 20px;\n          position: fixed;\n          top: 0;\n          right: 0;\n          width: 300px;\n          background: #fff;\n          padding: 20px;\n          box-shadow: -2px 0 5px rgba(0, 0, 0, 0.2);\n        }\n        .cancel-button {\n            display: flex;\n            align-items: center;\n            justify-content: center;\n            margin-top: 10px;\n            background-color: #dc3545;\n            color: #fff;\n            border: none;\n            padding: 10px 20px;\n            border-radius: 5px;\n            cursor: pointer;\n            height: 30px; \n        }\n        .cancel-button:hover {\n          background-color: #c82333;\n        }\n        .side-menu {\n            position: fixed;\n            top: 30px; /* Added top padding */\n            right: 0;\n            height: calc(100% - 60px); /* Full height minus top and bottom padding */\n            padding-top: 30px; /* Added top padding */\n            padding-bottom: 30px; /* Added bottom padding */\n            width: 300px;\n            background: #fff;\n            padding: 20px;\n            box-shadow: -2px 0 5px rgba(0, 0, 0, 0.2);\n            overflow-y: auto;\n          }\n          .side-menu h2 {\n            margin-top: 0;\n          }\n          .side-menu h3 {\n            margin-top: 0;\n          }\n          .side-menu form {\n            display: flex;\n            flex-direction: column;\n          }\n          .side-menu label {\n            margin-top: 10px;\n          }\n          .side-menu input, .side-menu select {\n            margin-top: 5px;\n            padding: 8px;\n            border: 1px solid #ddd;\n            border-radius: 4px;\n          }\n          .side-menu button {\n            margin-top: 20px;\n            background-color: #000000;\n            color: #fff;\n            border: none;\n            padding: 10px;\n            border-radius: 5px;\n            cursor: pointer;\n          }\n          .side-menu button:hover {\n            background-color: #000000;\n          }\n          .cancel-button {\n            margin-top: 10px;\n            background-color: #dc3545;\n            color: #fff;\n            border: none;\n            padding: 10px;\n            border-radius: 5px;\n            cursor: pointer;\n          }\n          .cancel-button:hover {\n            background-color: #c82333;\n          }\n      "}</style>
      </div>

    </div>);
}
