var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { css } from '@stitches/core';
import { generateClassNames } from 'pasubot-auth-ui-shared';
var messageDefaultStyles = css({
    fontFamily: '$bodyFontFamily',
    fontSize: '$baseInputSize',
    marginBottom: '$labelBottomMargin',
    display: 'block',
    textAlign: 'center',
    borderRadius: '0.375rem',
    padding: '1.5rem 1rem',
    lineHeight: '1rem',
    color: '$messageText',
    backgroundColor: '$messageBackground',
    border: '1px solid $messageBorder',
    variants: {
        color: {
            danger: {
                color: '$messageTextDanger',
                backgroundColor: '$messageBackgroundDanger',
                border: '1px solid $messageBorderDanger',
            },
        },
    },
});
var Message = function (_a) {
    var _b;
    var children = _a.children, appearance = _a.appearance, props = __rest(_a, ["children", "appearance"]);
    var classNames = generateClassNames('message', messageDefaultStyles({ color: props.color }), appearance);
    return (<span {...props} style={(_b = appearance === null || appearance === void 0 ? void 0 : appearance.style) === null || _b === void 0 ? void 0 : _b.message} className={classNames.join(' ')}>
      {children}
    </span>);
};
export { Message };
